<template>
  <v-row>
    <v-col v-for="(movie, index) in movies" :key="index" cols="12" md="6" lg="4" xl="3">
      <v-card>
        <v-card-title>
          {{ movie.Title }}
        </v-card-title>
        <v-img :src="movie.Poster" height="350"> </v-img>
        <v-card-text>
          Year: {{ movie.Year }} <br />
          Type: {{ movie.Type }}
        </v-card-text>
        <v-card-text>
          <v-btn block color="success" @click="selectMovie(movie)"> BUY OR RENT </v-btn>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>

  <v-snackbar v-model="snackbar" :timeout="3000" color="success">
    Added to Cart
    <template v-slot:actions>
      <v-btn variant="text" @click="snackbar = false"> Close </v-btn>
    </template>
  </v-snackbar>

  <v-dialog v-model="dialog" width="720">
    <v-card>
      <v-card-title> {{ selectedMovie.Title }} </v-card-title>
      <v-card-text>
        <v-row>
          <v-col cols="12" md="7"><v-img :src="selectedMovie.Poster" height="450"> </v-img></v-col>
          <v-col cols="12" md="5">
            <h3 class="mb-3">Buy or Rent</h3>
            <v-form ref="form">
              <v-select
                label="Select option"
                placeholder="Select option"
                v-model="form.type"
                :items="[
                  { title: 'Buy', value: 'buying' },
                  { title: 'Rent', value: 'renting' }
                ]"
                :rules="rules.type"
                variant="outlined"
              >
              </v-select>

              <v-text-field
                :label="`How many are you ${form.type === 'buying' ? 'Buying' : 'Renting'}`"
                v-model.number="form.qty"
                type="number"
                min="1"
                max="9"
                :rules="rules.qty"
                variant="outlined"
              >
              </v-text-field>
              <template v-if="form.type === 'renting'">
                <small> Select the dates of renting </small>

                <VueDatePicker
                  range
                  placeholder="Select the date of renting"
                  v-model="form.date"
                  :min-date="new Date()"
                  :enable-time-picker="false"
                  dark
                  position="right"
                  class="mb-5"
                  format="MM/dd/yyyy"
                  :auto-apply="true"
                  :clearable="false"
                ></VueDatePicker>
              </template>
              <v-btn
                block
                color="success"
                @click="onClickAddToCart()"
                :disabled="!form.type"
              >
                Add to cart
              </v-btn>
              <v-btn
                block
                color="success"
                class="mt-3"
                @click="$router.push(`/cart`)"
                v-if="userInteracted"
              >
                Go to cart
              </v-btn>
            </v-form>
          </v-col>
          <v-col cols="12">
            <p><strong>Year:</strong> {{ selectedMovie.Year }}</p>
            <p>
              <v-btn
                @click="loadMoreInfo"
                v-if="!loadedMoreInfo"
                block
                color="info"
                variant="outlined"
                >Load more Info</v-btn
              >
            </p>
            <template v-if="loadedMoreInfo">
              <p><strong>Genre:</strong> {{ selectedMovie.Genre }}</p>
              <p><strong>Actors:</strong> {{ selectedMovie.Actors }}</p>
              <p><strong>Plot:</strong> {{ selectedMovie.Plot }}</p>
            </template>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapActions } from 'pinia'
import { cartStore } from '../stores/cart'
import VueDatePicker from '@vuepic/vue-datepicker'
import '@vuepic/vue-datepicker/dist/main.css'
export default {
  name: 'MovieList',
  props: {
    movies: {
      type: Array,
      default: () => []
    }
  },
  components: {
    VueDatePicker
  },
  data() {
    return {
      dialog: false,
      selectedMovie: {},
      loadedMoreInfo: false,
      form: {
        type: null,
        qty: 1,
        date: []
      },
      rules: {
        type: [
          (value) => {
            if (value) return true
            return 'Select the type'
          }
        ],
        qty: [
          (value) => {
            if (value > 0) return true
            return 'You must select at least 1'
          }
        ]
      },
      snackbar: false,
      userInteracted: false
    }
  },
  methods: {
    async selectMovie(movie) {
      this.selectedMovie = movie
      this.loadedMoreInfo = false
      this.resetForm()
      const startDate = new Date()
      this.form.date = [startDate, new Date().setDate(startDate.getDate() + 7)]
      this.dialog = true
    },
    resetForm() {
      this.form.type = null
      this.form.qty = 1
      this.form.date = []
    },
    async loadMoreInfo() {
      const { data } = await this.axios.get(
        `https://www.omdbapi.com/?apikey=5eec5adc&i=${this.selectedMovie.imdbID}`
      )
      if (data && data.Response !== 'False') {
        this.selectedMovie = data
        this.loadedMoreInfo = true
        return
      }
      this.loadedMoreInfo = false
    },
    async onClickAddToCart() {
      const { valid } = await this.$refs.form.validate()
      if (!valid) return
      this.addToCart({
        type: this.form.type,
        movie: this.selectedMovie,
        qty: this.form.qty,
        id: this.selectedMovie.imdbID,
        date: this.form.type === 'renting' ? this.form.date : null
      })
      this.snackbar = true
      this.form.type = null
      this.form.qty = 1
      this.form.date = new Date()
      this.userInteracted = true
    },
    ...mapActions(cartStore, ['addToCart'])
  }
}
</script>
